//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2011-2011 - DIGITEO - Bruno JOFRET
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//
//

function [x,y,typ]=AUTO_SCOPE(job,arg1,arg2)
  x=[];y=[];typ=[];
  select job
   case 'plot' then
// deprecated
   case 'getinputs' then
// deprecater
   case 'getoutputs' then
// deprecated
   case 'getorigin' then
// deprecated
   case 'set' then
    x=arg1;
    graphics=arg1.graphics;
    exprs=graphics.exprs
    model=arg1.model;
    
    if ~exists("tf") then tf=100
    end
    
    while %t do
      [ok,num_points,name,exprs]=scicos_getvalue('Scope parameters',..
                                                ['Number of points';'Scope Name (optional)'], ..
                                                list('vec',1,'str','-1'),list(model.rpar.objs(3).model.rpar.objs(2).graphics.exprs(1),model.rpar.objs(2).graphics.exprs(10)))
          mess=[];

          if ~ok then
// Cancel
              break;
          end

          if num_points <= 0
              mess=[mess ;_("Number of points must be positive.")]
              ok = %f
          end
          
          
          if ok then
// Everything's ok
              model.rpar.objs(3).model.rpar.objs(2).graphics.exprs=[exprs(1);"0"]
              model.rpar.objs(3).model.rpar.objs(2).model.rpar=[tf/num_points;0]
              model.rpar.objs(2).graphics.exprs(10)=name
              model.rpar.objs(2).model.rpar(4)=tf
              //model.rpar.objs(2).model.ipar(3)=tf
              x.model=model;
              break
          else
              message(mess);
          end

      end
     case 'define' then
    scope=CSCOPE('define')
    scope.graphics.orig=[200,-180]
    scope.graphics.sz=[40,40]
    scope.graphics.flip=%t
    scope.graphics.exprs=["1 3 5 7 9 11 13 15";"-1";"[]";"[600;400]";"-15";"15";"tf";"tf";"0";""]
    scope.graphics.pin=4
    scope.graphics.pein=5
    
    
    clockc=CLOCK_c('define')
    clockc.graphics.orig=[200,-100]
    clockc.graphics.sz=[40,40]
    clockc.graphics.flip=%t
    clockc.graphics.exprs=[]
    clockc.graphics.peout=5
    clockc.model.rpar.objs(2).model.rpar=[0.1;0]
    clockc.model.rpar.objs(2).graphics.exprs=["200";"0"]
    
    input_port=IN_f('define')
    input_port.graphics.orig=[100,-180]
    input_port.graphics.sz=[40,50]
    input_port.graphics.flip=%t
    input_port.graphics.exprs=["1"]
    input_port.graphics.pout=4
    input_port.model.ipar=[1]
    
    
    diagram=scicos_diagram();
    diagram.objs(1)=input_port;   
    diagram.objs(2)=scope;
    diagram.objs(3)=clockc;
    diagram.objs(4)=scicos_link(xx=[120;180],yy=[-180;-180],..
				ct=[1,1],from=[1,1],to=[2,1])  
    diagram.objs(5)=scicos_link(xx=[260;260],..
				yy=[-104;-136],..
				ct=[5,-1],from=[3,1],to=[2,1]) 
    x=scicos_block()
    x.gui='AUTO_SCOPE'
    x.graphics.sz=[2,2]
    //x.graphics.gr_i=gr_i
    x.graphics.pin=0
    //x.model.sim='super'
    x.model.sim='csuper'
    //x.model.in=[1,1]
    x.model.in=-1
    x.model.in2=-2
    x.model.intyp=-1
    x.model.blocktype='h'
    x.model.firing=[]
    x.model.dep_ut=[%f %f]
    x.model.rpar=diagram
    x.model.ipar=1   //Test au hasard ou presque
    
 end
 endfunction        
         
