//
// Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
// Copyright (C) 2011-2011 - DIGITEO - Bruno JOFRET
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
//
//

function [x,y,typ]=BODE(job,arg1,arg2)
  x=[];y=[];typ=[];
  select job
   case 'plot' then
// deprecated
   case 'getinputs' then
// deprecater
   case 'getoutputs' then
// deprecated
   case 'getorigin' then
// deprecated
   case 'set' then
    x=arg1;
    graphics=arg1.graphics;
    exprs=graphics.exprs
    model=arg1.model;
    while %t do
      [ok,inputPortNumber,outputPortNumber, exprs]=scicos_getvalue('Set BODE Input/Output port',..
                                                ['Input Port Number';'Output Port Number'], ..
                                                list('vec',1, 'vec', 1),exprs)
          mess=[];

          if ~ok then
// Cancel
              break;
          end

          if inputPortNumber <= 0 | outputPortNumber <= 0
              mess=[mess ;_("Port Number must be positive.")]
              ok = %f
          end
          if (inputPortNumber <> int(inputPortNumber)) | (outputPortNumber <> int(outputPortNumber))
              mess=[mess; _("Port Number must be an integer.")]
              ok = %f
          end
          if ok then
// Everything's ok
              model.rpar=[inputPortNumber;outputPortNumber]
              graphics.exprs=exprs;
              x.model=model;
              x.graphics=graphics;
              break;
          else
              message(mess);
          end

      end
     case 'define' then
      model=scicos_model();
        k=1;
        model.sim=list("BODE",99) // 99 type blocks are ignored by simulator.
        model.blocktype='c';
        model.dep_ut=[%f %f];
        model.in=[];
        model.intyp=[];
        model.out=[];
        model.outtyp=[];
        model.rpar=[1;1];
        x=standard_define([2 2],model,[],[]);
        x.graphics.in_implicit=[];
        x.graphics.out_implicit=[];
        x.graphics.style=["blockWithLabel;verticalLabelPosition=center;displayedLabel=Bode"]
        x.graphics.exprs=["1";"1"]
    end
endfunction
